/* GCC */

#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <string>
using namespace std;

#define NAME "umbrella"

int m, n;

void show(vector <int> &v, string s)
{
    if (false)
    {
        cout << s << ": ";
        for (int i = 0; i < v.size(); ++i)
            cout << v[i] << ' ';
        cout << endl;
    }
}

bool check(vector<int>& c)
{
    bool fl = true;
    int t = c[0];
    for (int i =1; i< c.size(); ++i)
        if (c[i] != t)
        {
            fl = false;
            break;
        }

    return !fl;
}

vector<vector<int> > d;
unsigned long long k  = 0;

void shift(vector<int>& a)
{
    int t = a[0];
    for (int i = 0; i < a.size() -1; ++i)
    {
        a[i] = a[i+1];
    }
    a[a.size()-1] = t;
}

bool check2(vector <int>& a)
{

    vector<int> t = a;
    shift(t);

    while (a != t)
    {

        if (count(d.begin(), d.end(), t) >= 1)
            return false;
        shift(t);
    }
    return true;
}
void backtrack(int i, vector<int>& a)
{
    if (i == n )
    {

        if (/*check(a) &&*/ check2(a))
        {

            k++;
            d.push_back(a);
        }
        return;
    }
    else
    {
        for (int j = 0; j < m ; ++j)
        {
            a[i] = j;
            backtrack(i+1, a);

        }
    }
}


int main()
{
    ifstream fin(NAME ".in");
    ofstream fout(NAME ".out");


    fin >> n >> m;


    vector<int> v(n);

    backtrack(0, v);
    fout << k << endl;


    fin.close();
    fout.close();
    return 0;
}
