/* GCC */
#include <fstream>

using namespace std;

int ways[45000];

void vec_inc()
{
    ways[0]++;
    if(ways[0] < 10)
        return;
    ways[0] = 0;
    int carry = 1;
    for(int i = 1; i < 45000; i++)
    {
        if(carry == 0)
            return;
        ways[i] += carry;
        carry = 0;
        if(ways[i] > 9)
        {
            ways[i] -= 10;
            carry = 1;
        }
    }
}

void f(int camps_left, int length_left)
{
    if(camps_left == 1)
    {
        for(int i = 0; i < length_left - 1; i++)
            vec_inc();
        return;
    }
    if((length_left - camps_left) > 1 && length_left > 1)
    {
        f(camps_left, length_left-1);
        vec_inc();
        if(camps_left > 1)
        {
            f(camps_left-1, length_left-1);
            vec_inc();
        }
    }
    if((length_left - camps_left) == 1 && camps_left > 0)
        vec_inc();
}

int main()
{
    for(int i = 0; i < 45000; i++)
        ways[i] = 0;
    fstream fs;
    int a, b;
    fs.open("camps.in", fstream::in);
    fs >> a >> b;
    fs.close();
    f(b, a);
    fs.open("camps.out", fstream::out);
    int st;
    for(int i = 45000; i >=0; i--)
    {
        if(ways[i] != 0 )
        {
            st = i;
            break;
        }
    }
    for(int i = st; i >= 0; i--)
        fs << ways[i];
    fs.close();
    return 0;
}
