/* GCC */
#include <iostream>
#include <fstream>
#include <algorithm>
#include <string>
#include <map>
#include <math.h>
#include <vector>
#include <queue>
#include <set>
typedef long long LL;

using namespace std;

LL n,m;
const LL inf=1000000000000000000LL;
set <LL> s;
set <LL> city;
LL g[4100][4100];
LL g1[4100][4100];
LL cost[4100];
LL r[4100];
LL ans=0;

int main()
{
ios_base::sync_with_stdio(0);
freopen("roads.in","r",stdin);
freopen("roads.out","w",stdout);

cin>>n>>m;
LL a,b,c;

for (LL i=1; i<=m; i++)
for (LL j=1; j<=m; j++) g[i][j]=inf;

for (LL i=1; i<=m; i++) { cin>>a>>b>>c; g[a][b]=c; g[b][a]=c; g1[a][b]=i; g1[b][a]=i; }
for (LL i=1; i<=n; i++) cost[i]=inf;

cost[1]=0;
s.insert(1);
r[1]=-1;

while (!s.empty())
{
    LL u=*s.begin();
    s.erase(s.begin());
    for (LL j=1; j<=n; j++)
    if (cost[j]>=cost[u]+g[u][j])
    {
        cost[j]=cost[u]+g[u][j];
        r[j]=u;
        s.insert(j);
    }
}
for (LL i=n; i>1; i--) city.insert(i);
while (city.size()!=1)
    {
        LL v=*city.begin();
        city.erase(city.begin());
        cout<<g1[v][r[v]]<<" ";
    }
LL v=*city.begin();
cout<<g1[v][r[v]]<<endl;

    return 0;
}
