/* GCC */

#include <iostream>
#include <cmath>

using namespace std;

const int MAX1=1e6, MAX2=200001;

int n, s, carry, now, *arr, *ans, tmp, help[MAX2], temp;
bool flag;

void mult(int num)
{
    for (int i=0; i<MAX1; ++i) ans[i]=0;
    int j=0;
    while(num>=1)
    {
        now=num%10;
        carry=0;
        int i=MAX1-1-j;
        for (i=MAX1-1-j; i>0; i--)
        {
            ans[i]+=arr[i+j]*now+carry;
            carry=ans[i]/10;
            ans[i]%=10;
        }
        j++;
        num/=10;
    }
    swap(arr, ans);
}

int main()
{
    ios::sync_with_stdio(0);
    arr=new(int[MAX1]);
    ans=new(int[MAX1]);
    for (int i=0; i<MAX1; ++i) arr[i]=0;
    arr[MAX1-1]=1;
    cin >> n >> s;
    n--;
    for (int j=2; j<=n-s; ++j)
        {
            temp=j;
            for (int k=2; k<=sqrt(temp); ++k)
            {
                while(temp%k==0&&temp>1)
                {
                    help[k]++;
                    temp/=k;
                }
            }
        }
    for (int i=0; i<=n-s-1; ++i)
    {
        tmp=i+s+1;
        for (int j=2; j<=MAX2&&tmp>1; ++j)
        {
            if(tmp%j==0&&help[j]!=0)
            {
                help[j]--;
                tmp/=j;
            }
        }
        mult(tmp);
    }
    for (int i=0; i<MAX1; i++)
        if(arr[i]!=0||flag)
            cout << arr[i], flag=true;
    return 0;
}
