/* GCC */
#include <cstdio>
#include <cstdlib>
#include <string>
#include <iostream>
#define number unsigned long long
//#define number clever

using namespace std;

string int2string(const int &x) {
    char *xrepr = new char[16];
    itoa(x, xrepr, 10);
    string s(xrepr);
    delete xrepr;
    return s;
}

int8_t tr(char x) {
    return x-'0';
}

char trb(int8_t x) {
    return x+'0';
}

string multiply(string x, string y) {
    string z;
    z.reserve(x.length()+y.length());

    for (size_t i = y.length()-1; i >= 0; i--) {
        int buffer = 0;

        for (size_t j = x.length()-1; j >= 0; j--) {
            int a = tr(y[i]), b = tr(x[j]);

            buffer += a*b;

            z.insert(z.begin(), trb(buffer%10));
            buffer %= 10;
        }
    }

    reverse(z.begin(), z.end());
    return z;
}

class clever {
public:
    clever() {}
    ~clever() {}

    clever(int x) {
        repr = int2string(x);
    }

    clever(string r) {
        repr = r;
    }

    bool operator!= (const int &x) {
        return !cmp(x);
    }

    bool operator== (const int &x) {
        return cmp(x);
    }

    bool cmp(const int &x) {
        return int2string(x) == repr;
    }

    clever operator* (clever b) {
        clever a = *this;
        if (a < b) {
            swap(a, b);
        }

        string x = a.repr, y = b.repr;
        return clever(multiply(x, y));
    }

    clever operator/ (clever y) {
        return y;
    }

    bool operator< (const clever &y) {
        if (repr.length() < y.repr.length()) {
            return true;
        } else if (repr.length() > y.repr.length()) {
            return false;
        } else {
            for (size_t i = 0; i < repr.length(); i++) {
                if (repr[i] < y.repr[i]) {
                    return true;
                } else if (repr[i] > y.repr[i]) {
                    return false;
                }
            }
        }

        return false;
    }

    string repr;
};

int s, n;

number cacheN, cacheSsubN;

number F(int x) {
    if (x == n && cacheN != 0) {
        return cacheN;
    }

    if (x == s-n && cacheSsubN != 0) {
        return cacheSsubN;
    }

    number y(1);
    for (int i = 2; i <= x; i++) {
        y = y*i;

        if (i == n)
           cacheN = y;
        if (i == s-n)
           cacheSsubN = y;
    }

    return y;
}

number Z(int s, int n) {
    number a = F(s);
    number b = F(n);
    number c = F(s-n);

    return a/(b*c);
}

int main() {
    freopen("camps.in", "r", stdin);
    freopen("camps.out", "w", stdout);

    scanf("%d %d\n", &s, &n);
    s--;

    cout << Z(s, n) << endl;

    return 0;

    return 0;
}











