/* GCC */
#include<stdio.h>
#include<vector>
#include<string.h>
#include<algorithm>
#define MX 10000000
using namespace std;
vector<int> long_multipl(vector<int> m1, vector<int> m2)
{
    __int64 tm;
    vector<int> t(m1.size()+ m2.size(), 0);
    for (int i = 0; i<m1.size(); i++)
        for (int j = 0; j<m2.size(); j++)
        {
            tm =(__int64) m1[i]*m2[j];
            t[i+j+1] = t[i+j+1] + ((__int64) (t[i+j] + tm) / MX);
            t[i+j] = ((__int64) (t[i+j] + tm) % MX);
        }
    for (int i=0; i<t.size()-1; i++)
    {
        t[i+1] = t[i+1] + (t[i]/MX);
        t[i] = t[i] % MX;
    }
    while (t[t.size()-1] == 0 && t.size() > 1) t.pop_back();
    return t;
}
main()
{
    int s2[20] = {1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072, 262144};
    FILE *fi = fopen("camps.in", "r"), *fo = fopen("camps.out", "w");
    int n, s, t, sp, tc;
    fscanf(fi, "%d%d", &s, &n);
    s = s-1;
    vector<int> res, stp[20], tsum;
    res.clear(); res.push_back(1);
    char p[200000];
    memset(p, 0, sizeof(p));
    for (int i = 2; i<=s; i++) if (p[i] == 0)
    {
        for (int j=i; j<=s; j = j+i) p[j] = 1;
        t = s / i; tc = 0;
        while (t > 0)
        {
            tc = tc + t;
            t = t / i;
        }
        sp = tc;
        t = n / i; tc = 0;
        while (t > 0)
        {
            tc = tc + t;
            t = t / i;
        }
        sp = sp - tc;
        t = (s-n) / i; tc = 0;
        while (t > 0)
        {
            tc = tc + t;
            t = t / i;
        }
        sp = sp - tc;
        stp[1].clear();
        stp[1].push_back(i);
        for (int j = 2; s2[j-1]<=sp; j++)
        {
            stp[j].clear();
            stp[j] = long_multipl(stp[j-1], stp[j-1]);
        }
        int ud = 18;
        tsum.clear();
        tsum.push_back(1);
        while (sp > 0)
        {
            if (sp >= s2[ud-1]) {
                tsum = long_multipl(tsum, stp[ud]);
                sp =sp - s2[ud-1];
            }
            ud--;
        }

        res = long_multipl(res, tsum);
    }
    reverse(res.begin(), res.end());
    fprintf(fo, "%d", *res.begin());
    char w[10];
    for(vector<int>::iterator ai=res.begin()+1; ai<res.end(); ai++)
    {
        sprintf(w, "%d", *ai);
        for (int i = 0; i<(7-strlen(w)); i++) fprintf(fo, "0");
        fprintf(fo, "%s", w);
    }
    fprintf(fo, "\n");
    fclose(fi);
    fclose(fo);
    return 0;
}
