/* GCC */

#include <iostream>
#include <fstream>

using namespace std;

typedef unsigned long long ull;

ull n, m, ans, tmp;

ull mypow(ull a, ull b)
{
    ull c=1;
    while(b)
    {
        if(b&1) c*=a;
        a*=a;
        b>>=1;
    }
    return c;
}

ull gcd(ull a, ull b)
{
    while(b)
    {
        a%=b;
        swap(a, b);
    }
    return a;
}

int main()
{
    ifstream cin("umbrella.in");
    ofstream cout("umbrella.out");
    cin >> n >> m;
    ans=mypow(m, n-1)-1;
    tmp=gcd(n, m);
    n/=tmp;
    m/=tmp;
    tmp=m*tmp;
    ans/=n;
    ans*=m;
    cout << ans+tmp;
    return 0;
}
