/* GCC */
#include <iostream>
#include <utility>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;
pair<size_t, size_t> gr[4097][4097];
vector<size_t> ans;
size_t dist[4097];
size_t dist_from[4097];
bool used[4097] = {};

int main(void)
{
    size_t n, m, tmp1, tmp2, cost;
    ifstream in("roads.in");
    in >> n >> m;
    for(size_t i = 1; i <= m; ++i)
    {
        in >> tmp1 >> tmp2 >> cost;
        gr[tmp1][tmp2] = gr[tmp2][tmp1] = make_pair(cost, i);
    }
    in.close();
    ans.reserve(n-1);
    for(size_t i = 2; i <= n; ++i)
        if(gr[1][i].first)
            dist[i] = gr[1][i].first, dist_from[i] = 1;
        else
            dist[i] = 0xffffffff;
    used[1] = true, dist[1] = 0, dist[0] = 0xffffffff;
    for(size_t _ = 1; _ < n; ++_)
    {
        size_t u = 0;
        for(size_t i = 1; i <= n; ++i)
            if(!used[i] && dist[i] < dist[u])
                u = i;
        used[u] = true;
        ans.push_back(gr[u][dist_from[u]].second);
        for(size_t i = 1; i <= n; ++i)
            if(!used[i] && gr[u][i].first && gr[u][i].first < dist[i])
                dist[i] = gr[u][i].first, dist_from[i] = u;
    }
    ofstream out("roads.out");
    out << ans[0];
    for(size_t i = 1; i < ans.size(); ++i)
        out << ' ' << ans[i];
    out << endl;
    out.close();
    return 0;
}
