/* GCC */
#include <fstream>

typedef unsigned long long Num;
using namespace std;

Num power(Num base, Num exp)
{return exp == 0 ? 1 : base*power(base, exp-1);}

int main(void)
{
    Num n, m, y[20], ans(0);
    ifstream in("umbrella.in");
    in >> n >> m;
    in.close();
    y[1] = m;
    for(Num i = 2; i <= n; ++i)
    {
        y[i] = power(m, i);
        for(Num j = 1; j < i; ++j)
            if(i % j == 0)
                y[i] -= j*y[j];
        y[i] /= i;
    }
    ofstream out("umbrella.out");
    for(Num i = 1; i <= n; ++i)
        if(n % i == 0)
            ans += y[i];
    out << ans << endl;
    out.close();
    return 0;
}
